package com.frikinjay.letmedespawn.mixin;

import com.frikinjay.almanac.Almanac;
import com.frikinjay.letmedespawn.LetMeDespawn;
import net.minecraft.class_1299;
import net.minecraft.class_1304;
import net.minecraft.class_1308;
import net.minecraft.class_1309;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.Redirect;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin({class_1308.class})
public abstract class MobMixin extends class_1309 {
   protected MobMixin(class_1299<? extends class_1309> entityType, class_1937 level) {
      super(entityType, level);
   }

   @Inject(
      at = {@At("TAIL")},
      method = {"setItemSlotAndDropWhenKilled"}
   )
   private void letmedespawn$setItemSlotAndDropWhenKilled(class_1304 slot, class_1799 stack, CallbackInfo info) {
      class_1308 entity = (class_1308)this;
      LetMeDespawn.setPersistence(entity, slot);
   }

   @Redirect(
      method = {"checkDespawn"},
      at = @At(
   value = "INVOKE",
   target = "Lnet/minecraft/world/entity/Mob;discard()V"
)
   )
   private void letmedespawn$yeetusCheckus(class_1308 instance) {
      class_1799 headItem = instance.method_6118(class_1304.field_6169);
      if (!LetMeDespawn.config.getPersistenceEnablers().contains(LetMeDespawn.getItemKey(headItem, instance))) {
         if (Almanac.pickedItems) {
            Almanac.dropEquipmentOnDiscard(instance);
         }

         this.method_31472();
      }

   }
}
